package com.unitesk.requality.core;

import java.io.InputStream;
import java.util.Collection;
import java.util.UUID;

public interface ITreeStorage {

    public abstract void setDeltaTarget(IStorageDeltaListener deltaProcessor);

    public abstract IStorageDeltaListener getDeltaTarget();

    public abstract void createNode(UUID parentNode, UUID node, String type,
            String id);

    public abstract String getNodeType(UUID uuid);

    abstract public UUID getRootNode();

    abstract public UUID getParent(UUID uuid);

    abstract public Collection<UUID> getChildren(UUID uuid);

    abstract public void createNode(UUID parentUUId, UUID uuid, String id,
            Collection<Attribute> attrs);

    abstract public void remove(UUID uuid);

    abstract public String getNodeId(UUID uuid);

    abstract public void changeNodeId(UUID uuid, String id);

    abstract public Collection<Attribute> getAttributes(UUID uuid);

    abstract public void saveAttributes(UUID uuid,
            Collection<Attribute> attributes);

    abstract public void moveNodeTo(UUID uuid, UUID parent);

    abstract public boolean canLoad(UUID uuid);

    abstract public boolean isResourceExists(UUID uuid, String resName);

    abstract public String getNodeResourcePath(UUID uuid);

    abstract public InputStream getResourceContents(UUID uuid, String resName);

    abstract public void setResourceContents(UUID uuid, String resName,
            InputStream in, Object data);

    abstract public String[] listResources(UUID uuid);

    abstract public void deleteResource(UUID uuid, String resName);

    abstract public void createStorage(String name);

    abstract public void deleteStorage();

    abstract public String getName();

}