package com.unitesk.requality.core.checkers;

import java.util.ArrayList;
import java.util.List;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.nodetypes.Location;
import com.unitesk.requality.nodetypes.Requirement;

public class LocationRefsChecker implements IChecker {
    public LocationRefsChecker() {
    }

    @Override
    public  CheckerProblem[] check(TreeNode node) {
        ArrayList<CheckerProblem> result = new ArrayList<CheckerProblem>();
        if (!(node instanceof Requirement)) {
            return result.toArray(new CheckerProblem[0]);
        }
        Requirement req = (Requirement) node;
        List<String> locQIds = req.getLocationQIds();
        for (String qid : locQIds) {
            TreeNode location = req.getTreeDB().getNode(qid);
            if (location == null) {
                result.add(new CheckerProblem(req, "Location with QId: " + qid
                        + " not found")); 
            } else if (!location.getType().equals(Location.TYPE_NAME)) {
                result.add(new CheckerProblem(req, "Location with QId: " + qid
                        + " has wrong type " + location.getType()));
            }
        }
        return result.toArray(new CheckerProblem[0]);
    }

}
