package com.unitesk.requality.core.transaction;

import java.util.Collection;
import java.util.TreeSet;
import java.util.UUID;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.ITreeStorage;

public class SaveAttributes extends TreeOperation {
    private UUID uuid;
    private Collection<Attribute> oldAttributes;
    private Collection<Attribute> newAttributes;

    public SaveAttributes(UUID uuid, Collection<Attribute> oldAttributes, Collection<Attribute> newAttributes) {
        this.uuid = uuid;
        //deeply copy attributes
        this.oldAttributes = new TreeSet<Attribute>();
        for (Attribute oldAttr : oldAttributes) {
            this.oldAttributes.add(Attribute.deepCopy(oldAttr));
        }
        this.newAttributes = new TreeSet<Attribute>();
        for (Attribute newAttr : newAttributes) {
            this.newAttributes.add(Attribute.deepCopy(newAttr));
        }
    }
    
    @Override
    public void apply(ITreeStorage storage) {
        storage.saveAttributes(uuid, newAttributes);
    }

    @Override
    public void rollback(ITreeStorage storage) {
        storage.saveAttributes(uuid, oldAttributes);
    }

}
